'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = createActionAsync;

var _reduxAct = require('redux-act');

function createActionAsync(description, api) {
  var options = arguments.length <= 2 || arguments[2] === undefined ? {} : arguments[2];


  var actions = {
    request: (0, _reduxAct.createAction)(description + '_REQUEST', options.payloadReducer, options.metaReducer),
    ok: (0, _reduxAct.createAction)(description + '_OK', options.payloadReducer, options.metaReducer),
    error: (0, _reduxAct.createAction)(description + '_ERROR', options.payloadReducer, options.metaReducer)
  };

  var actionAsync = function actionAsync() {
    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return function (dispatch) {
      dispatch(actions.request());
      return api.apply(undefined, args).then(function (res) {
        dispatch(actions.ok(res));
      }).catch(function (err) {
        dispatch(actions.error(err));
        if (!options.noRethrow) throw err;
      });
    };
  };

  actionAsync.request = actions.request;
  actionAsync.ok = actions.ok;
  actionAsync.error = actions.error;
  return actionAsync;
};